/*                      LEKCJA11.C
//---------------------------------------------------------------------------
Temat:
        Numer identyfikacyjny elementu  
        Wybr pojedynczego elementu i zmiana jego atrybutw
//---------------------------------------------------------------------------
Funkcje:
        EXT(219) short ClickEntity(   
        EXT(220) ulong ExChangeEntity(
//---------------------------------------------------------------------------

   Numer ID
   Kademu elementowi rysunku w czasie pracy programu MegaCAD jest przypisany
   numer identyfikacyjny 'ID'. Numer ten jest nadawany podczas tworzenia 
   elementu lub dokonywania zmian. 
   Nie jest on natomiast integraln czci pliku rysunkowego! 
   To znaczy, e temu samemu elementowi rysunku moe w nastpnym uruchomieniu 
   programu zosta przypisany inny numer ID.
//---------------------------------------------------------------------------

EXT(219) short ClickEntity(   
        ulong       filter,   // filtr definiujcy typy elementw
        double      *pnt,     // wskazany punkt (x,y)
        t_entity    *ent,     // dane wybranego elementu
        void        *edta,    // bufor dla danych wirtualnych
        ushort      esiz);    // wielko bufora

    Funkcja pozwala wybra element poprzez wskazanie go kursorem.
    Dwuczonowy acuch '*pnt' przechowuje wsprzdne wskazanego punktu.
    Parametr 'filter' definiuje jakie typy elementw mog by wybrane,
    np. tylko linie: (1<<E_LINE). 
    Jeli filtr dopuszcza wybr elementw o zmiennej dugoci naley 
    przygotowa bufor '*edta' o dostatecznej wielkoci 'esiz' dla danych 
    definiujcych takie elementy  (tekst, wymiarowanie).
    W przypadku jeli nie dopuszcza si w filtrze typw o zmiennej dugoci
    bufor moe nie by definiowany - NULL.

Return:
    TRUE - po naciniciu lewego klawisze myszy
    FALSE - po naciniciu prawego klawisze myszy

Przykad wywoania:
    while ( ClickEntity(1<<E_LINE,pnt,&ent,NULL,0))
//---------------------------------------------------------------------------

EXT(220) ulong ExChangeEntity(// 
        t_entity    *ent);    // nowe dane dla starego elementu

    Funkcja umoliwia zmian danych istniejcego elementu.
    W rzeczywistoci zostaj podmienione dane starego elementu na nowe,
    a stare pozostaj w pamici z zaznaczeniem zmiany, to znaczy mona je 
    przywrci przy pomocy UNDO.
    Dane definiujce element musz by pene. W przypadku elementw o 
    zmiennej dugoci bufor nie moe rwna si NULL.
    
Return:
    ID - nowy numer identyfikacyjny
    0L - jeli wystpi bd

Przykad wywoania:
    ExChangeEntity(&ent);

*/
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
    t_entity  ent;
    double    pnt[2];     // rezerwacja miejsca dla wybranego punktu
    t_attribs *attr;
    ulong     ID_stary,ID_nowy;
    char      b1[50],b2[50];

    SetFuncText("zmiana koloru linii");
    MouseHelp("wybr linii","powrt",HLP_INV(0,0,0));

    while ( ClickEntity(1<<E_LINE,pnt,&ent,NULL,0) )
    {
        // zmiana atrybutw wybranego elementu
        attr = &ent.attr;
        ID_stary= ent.id;
        ent.attr.col ^= 0xf;
        ent.attr.col++;
        // zapisanie zmienionego elementu
        ID_nowy= ExChangeEntity(&ent);
        sprintf(b1,"stary ID= %ld",ID_stary);
        sprintf(b2,"nowy  ID= %ld",ID_nowy);
        Message(b1,b2,NULL,NULL,"ok",3);
        savecount();
    }
    return(0);
}
//---------------------------------------------------------------------------
